#include <iostream>
#include <string>
#include <vector>
#include <cstdio>





using namespace std;

struct ver{
    int mennyiseg,fajta;
    int eredmeny[4];
};

int main()
{
    int n,o,a,b,ab,i,z;
    vector<int> O,A,B,AB;
    char x,y;
    cin>>n;
    cin>>o>>a>>b>>ab;
    ver beteg[n];
    x=getchar();
    for(i=0;i<n;i++){
        x=getchar();
        y=getchar();
        cin>>z;
        if(y==' '){
            switch(x){
            case 'O':beteg[i].fajta=1;O.push_back(i);break;
            case 'A':beteg[i].fajta=2;A.push_back(i);break;
            case 'B':beteg[i].fajta=3;B.push_back(i);break;
            }
            beteg[i].mennyiseg=z;
        }
        else{
            beteg[i].fajta=4;
            beteg[i].mennyiseg=z;
            AB.push_back(i);
        }
        beteg[i].eredmeny[0]=0;
        beteg[i].eredmeny[1]=0;
        beteg[i].eredmeny[2]=0;
        beteg[i].eredmeny[3]=0;
        x=getchar();
    }

    for(i=0;i<O.size();i++){
        beteg[O[i]].eredmeny[0]=beteg[O[i]].mennyiseg;
        o=o-beteg[O[i]].mennyiseg;
    }
    for(i=0;i<A.size();i++){
        if(a>=(beteg[A[i]].mennyiseg)){
            beteg[A[i]].eredmeny[1]=beteg[A[i]].mennyiseg;
            a=a-beteg[A[i]].mennyiseg;
        }
        else{
            beteg[A[i]].eredmeny[1]=a;
            beteg[A[i]].mennyiseg=beteg[A[i]].mennyiseg-a;
            a=0;
            beteg[A[i]].eredmeny[0]=beteg[A[i]].mennyiseg;
            o=o-beteg[A[i]].mennyiseg;
        }
    }
    for(i=0;i<B.size();i++){
        if(b>=(beteg[B[i]].mennyiseg)){
            beteg[B[i]].eredmeny[2]=beteg[B[i]].mennyiseg;
            b=b-beteg[B[i]].mennyiseg;
        }
        else{
            beteg[B[i]].eredmeny[2]=b;
            beteg[B[i]].mennyiseg=beteg[B[i]].mennyiseg-b;
            b=0;
            beteg[B[i]].eredmeny[0]=beteg[B[i]].mennyiseg;
            o=o-beteg[B[i]].mennyiseg;
        }
    }
    for(i=0;i<AB.size();i++){
        if(ab>=(beteg[AB[i]].mennyiseg)){
            beteg[AB[i]].eredmeny[3]=beteg[AB[i]].mennyiseg;
            ab=ab-beteg[B[i]].mennyiseg;
        }
        else{
            beteg[AB[i]].eredmeny[3]=ab;
            beteg[AB[i]].mennyiseg=beteg[AB[i]].mennyiseg-ab;
            if(beteg[AB[i]].mennyiseg>0){
                if(b>=(beteg[AB[i]].mennyiseg)){
                    beteg[AB[i]].eredmeny[2]=beteg[AB[i]].mennyiseg;
                    b=b-beteg[AB[i]].mennyiseg;
                }
                else{
                    beteg[AB[i]].eredmeny[2]=b;
                    beteg[AB[i]].mennyiseg=beteg[B[i]].mennyiseg-b;
                    b=0;
                    if(a>=(beteg[AB[i]].mennyiseg)){
                        beteg[AB[i]].eredmeny[1]=beteg[AB[i]].mennyiseg;
                        a=a-beteg[AB[i]].mennyiseg;
                    }
                    else{
                        beteg[AB[i]].eredmeny[1]=a;
                        beteg[AB[i]].mennyiseg=beteg[AB[i]].mennyiseg-a;
                        a=0;
                        beteg[AB[i]].eredmeny[0]=beteg[AB[i]].mennyiseg;
                        o=o-beteg[AB[i]].mennyiseg;
                    }
                }
            }
        }
    }

    if(o<0){
        cout<<"nemoguce";
    }
    else{
        for(i=0;i<n;i++){
            cout<<beteg[i].eredmeny[0]<<" "<<beteg[i].eredmeny[1]<<" "<<beteg[i].eredmeny[2]<<" "<<beteg[i].eredmeny[3]<<"\n";
        }
    }

}